/*
 * Copyright (c) 2016 BiTel Inc. All rights reserved.
*/
package ru.bitel.mybgbilling.kernel.contract;

import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.bitel.bgbilling.common.BGException;
import ru.bitel.mybgbilling.kernel.common.AbstractBean;
import ru.bitel.mybgbilling.kernel.common.inject.BGInjection;

@Named
@SessionScoped
@BGInjection
public class TariffOptionActivateBean
	extends AbstractBean
{
	private static final Logger logger = LoggerFactory.getLogger( TariffOptionActivateBean.class );
	
	@Inject
	private TariffOptionBean tariffOptionBean;
	
	@Inject
	private NotificationBean notificationBean;

	private int tariffOptionId;

	private int tariffOptionActivateModeId;

	public int getTariffOptionId()
	{
		return tariffOptionId;
	}

	public void setTariffOptionId( int tariffOptionId )
	{
		this.tariffOptionId = tariffOptionId;
	}

	public int getTariffOptionActivateModeId()
	{
		return tariffOptionActivateModeId;
	}

	public void setTariffOptionActivateModeId( int tariffOptionActivateModeId )
	{
		this.tariffOptionActivateModeId = tariffOptionActivateModeId;
	}

	public void activate()
		throws BGException
	{
		/*if( conversation.isTransient() )
		{
			conversation.begin();
		}*/

		step = 1;
	}

	public void apply()
		throws BGException
	{
		if( step != 1 )
		{
			step = 0;
			return;
		}

		tariffOptionBean.activate( tariffOptionId, tariffOptionActivateModeId );

		try
		{
			notificationBean.populate();
		}
		catch( Exception ex )
		{
			logger.error( ex.getMessage(), ex );
		}

		step = 0;
	}
}
